void init() {
// 62.5 kHz internal oscillator
OSCCON.IRCF3 = 0;
OSCCON.IRCF2 = 1;
OSCCON.IRCF1 = 0;
OSCCON.IRCF0 = 0;

// Internal Oscillator is selected
OSCCON.SCS1 = 1;
OSCCON.SCS0 = 0;

//
TRISA = 0xFF;
TRISC = 0xDF;

}

void init_pwm1() {
PWM1CON = 0x00;

PR2 = 255;         // approximately 61Hz PWM
TMR2 = 0x00;
PIR1.TMR2IF = 0;
PIE1.TMR2IE = 0;
T2CON.TMR2ON = 1;

PWM1CON.PWM1EN = 1;
PWM1CON.PWM1OE = 1;
}



void main() {

unsigned int randomData = 28888;
unsigned char tempVal1 = 0;
unsigned char tempVal2 = 0;
unsigned char finalOutput = 0;

init();
delay_ms(5);
init_pwm1();
delay_ms(5);

PWM1DCH = 0b00111111;
PWM1DCL = 0b11000000;

while(1) {

// data = (data << 1) + (data.15 ^ data.12) (Myke Predko's Programming and Customizing the PIC Microcontroller, p.891)

tempVal1 = (randomData & (1 << 15)) >> 15;
tempVal2 = (randomData & (1 << 12)) >> 12;
randomData = (randomData << 1) + (tempVal1 ^ tempVal2);

finalOutput = randomData >> 8;

//PWM1DCH = finalOutput;
PWM1DCH = finalOutput >> 2;
PWM1DCL = finalOutput << 6;

delay_ms(50);

}


}