
_init:

;pic16f1503-candle.c,1 :: 		void init() {
;pic16f1503-candle.c,3 :: 		OSCCON.IRCF3 = 0;
	BCF        OSCCON+0, 6
;pic16f1503-candle.c,4 :: 		OSCCON.IRCF2 = 1;
	BSF        OSCCON+0, 5
;pic16f1503-candle.c,5 :: 		OSCCON.IRCF1 = 0;
	BCF        OSCCON+0, 4
;pic16f1503-candle.c,6 :: 		OSCCON.IRCF0 = 0;
	BCF        OSCCON+0, 3
;pic16f1503-candle.c,9 :: 		OSCCON.SCS1 = 1;
	BSF        OSCCON+0, 1
;pic16f1503-candle.c,10 :: 		OSCCON.SCS0 = 0;
	BCF        OSCCON+0, 0
;pic16f1503-candle.c,13 :: 		TRISA = 0xFF;
	MOVLW      255
	MOVWF      TRISA+0
;pic16f1503-candle.c,14 :: 		TRISC = 0xDF;
	MOVLW      223
	MOVWF      TRISC+0
;pic16f1503-candle.c,16 :: 		}
L_end_init:
	RETURN
; end of _init

_init_pwm1:

;pic16f1503-candle.c,18 :: 		void init_pwm1() {
;pic16f1503-candle.c,19 :: 		PWM1CON = 0x00;
	CLRF       PWM1CON+0
;pic16f1503-candle.c,21 :: 		PR2 = 255;         // approximately 61Hz PWM
	MOVLW      255
	MOVWF      PR2+0
;pic16f1503-candle.c,22 :: 		TMR2 = 0x00;
	CLRF       TMR2+0
;pic16f1503-candle.c,23 :: 		PIR1.TMR2IF = 0;
	BCF        PIR1+0, 1
;pic16f1503-candle.c,24 :: 		PIE1.TMR2IE = 0;
	BCF        PIE1+0, 1
;pic16f1503-candle.c,25 :: 		T2CON.TMR2ON = 1;
	BSF        T2CON+0, 2
;pic16f1503-candle.c,27 :: 		PWM1CON.PWM1EN = 1;
	BSF        PWM1CON+0, 7
;pic16f1503-candle.c,28 :: 		PWM1CON.PWM1OE = 1;
	BSF        PWM1CON+0, 6
;pic16f1503-candle.c,29 :: 		}
L_end_init_pwm1:
	RETURN
; end of _init_pwm1

_main:

;pic16f1503-candle.c,33 :: 		void main() {
;pic16f1503-candle.c,35 :: 		unsigned int randomData = 28888;
	MOVLW      216
	MOVWF      main_randomData_L0+0
	MOVLW      112
	MOVWF      main_randomData_L0+1
;pic16f1503-candle.c,40 :: 		init();
	CALL       _init+0
;pic16f1503-candle.c,41 :: 		delay_ms(5);
	MOVLW      25
	MOVWF      R13
L_main0:
	DECFSZ     R13, 1
	GOTO       L_main0
	NOP
	NOP
;pic16f1503-candle.c,42 :: 		init_pwm1();
	CALL       _init_pwm1+0
;pic16f1503-candle.c,43 :: 		delay_ms(5);
	MOVLW      25
	MOVWF      R13
L_main1:
	DECFSZ     R13, 1
	GOTO       L_main1
	NOP
	NOP
;pic16f1503-candle.c,45 :: 		PWM1DCH = 0b00111111;
	MOVLW      63
	MOVWF      PWM1DCH+0
;pic16f1503-candle.c,46 :: 		PWM1DCL = 0b11000000;
	MOVLW      192
	MOVWF      PWM1DCL+0
;pic16f1503-candle.c,48 :: 		while(1) {
L_main2:
;pic16f1503-candle.c,52 :: 		tempVal1 = (randomData & (1 << 15)) >> 15;
	MOVLW      0
	ANDWF      main_randomData_L0+0, 0
	MOVWF      R1
	MOVF       main_randomData_L0+1, 0
	ANDLW      128
	MOVWF      R2
	MOVLW      15
	MOVWF      R0
	MOVF       R1, 0
	MOVWF      R5
	MOVF       R2, 0
	MOVWF      R6
	MOVF       R0, 0
L__main8:
	BTFSC      STATUS+0, 2
	GOTO       L__main9
	LSRF       R6, 1
	RRF        R5, 1
	ADDLW      255
	GOTO       L__main8
L__main9:
;pic16f1503-candle.c,53 :: 		tempVal2 = (randomData & (1 << 12)) >> 12;
	MOVLW      0
	ANDWF      main_randomData_L0+0, 0
	MOVWF      R1
	MOVF       main_randomData_L0+1, 0
	ANDLW      16
	MOVWF      R2
	MOVLW      12
	MOVWF      R0
	MOVF       R1, 0
	MOVWF      R3
	MOVF       R2, 0
	MOVWF      R4
	MOVF       R0, 0
L__main10:
	BTFSC      STATUS+0, 2
	GOTO       L__main11
	LSRF       R4, 1
	RRF        R3, 1
	ADDLW      255
	GOTO       L__main10
L__main11:
;pic16f1503-candle.c,54 :: 		randomData = (randomData << 1) + (tempVal1 ^ tempVal2);
	MOVF       main_randomData_L0+0, 0
	MOVWF      R1
	MOVF       main_randomData_L0+1, 0
	MOVWF      R2
	LSLF       R1, 1
	RLF        R2, 1
	MOVF       R3, 0
	XORWF      R5, 0
	MOVWF      R0
	MOVF       R0, 0
	ADDWF      R1, 0
	MOVWF      R3
	MOVLW      0
	ADDWFC     R2, 0
	MOVWF      R4
	MOVF       R3, 0
	MOVWF      main_randomData_L0+0
	MOVF       R4, 0
	MOVWF      main_randomData_L0+1
;pic16f1503-candle.c,56 :: 		finalOutput = randomData >> 8;
	MOVF       R4, 0
	MOVWF      R0
	CLRF       R1
;pic16f1503-candle.c,58 :: 		PWM1DCH = finalOutput;
	MOVF       R0, 0
	MOVWF      PWM1DCH+0
;pic16f1503-candle.c,62 :: 		delay_ms(50);
	MOVLW      2
	MOVWF      R12
	MOVLW      2
	MOVWF      R13
L_main4:
	DECFSZ     R13, 1
	GOTO       L_main4
	DECFSZ     R12, 1
	GOTO       L_main4
;pic16f1503-candle.c,64 :: 		}
	GOTO       L_main2
;pic16f1503-candle.c,67 :: 		}
L_end_main:
	GOTO       $+0
; end of _main
